<?php
print "<B><U>Simulacin de sobrecarga de mtodos (ejemplo file095.php)</U></B><BR><BR>";

// Definicin de la clase Prueba
class Prueba {
    public $resultado;

	function __call($met, $var){
		// en el parmetro $met se recibe el nombre del mtodo
		//  en el parmetro $var se recibe una matriz con los
		// parmetros utilizados en la llamada al mtodo 

		if ($met == "test") {
		// aqu incluimos una lgica para gestionar la
		// sobrecarga
		
			// si la variable es integer se llama
			// a la funcin test para numricos
			if (gettype($var[0]) == "integer"){
				$this->test_numrico($var);
			}
			// caso contrario, se llama a la funcin
			// test para cadenas
			else {
				$this->test_cadena($var);
			}
		} 
	}

	// funcin privada para tratar parmetro integer
	private function test_numrico($var){
	    $this->resultado = $var[0] * 5;
	}

	// funcin privada para tratar parmetro cadena
	private function test_cadena($var){
	    $this->resultado = $var[0] . " es texto";
	}   
}	
$a = new Prueba;

// la sobrecarga de mtodos significa llamar a un mismo mtodo
// pero con distintos tipos de parmetros o con distinta
// cantidad de parmetros

// Aqu siempre se llama al mtodo Test
// el mtodo en realidad no existe, pero en la clase
// est definido el mtodo __call que recibe las llamadas a
// mtodos no existentes, 
// all podremos colocar la lgica necesaria para simular
// la sobrecarga de mtodos

$a->test(8);  // se usa el mtodo test con nmeros

print "Mtodo test: proceso con argumento numrico: " . 
   $a->resultado . "<BR>"; 

$a->test("Esto "); // se usa el mtodo test con cadenas

print "Mtodo test: proceso con argumento de cadena: " . 
   $a->resultado . "<BR>"; 
?>