<?php
// Uso de Interface Iterator archivo file104a.php

// uso de foreach sobre propiedades privadas

print "<B>Uso de interface Iterator (archivo file104a.php</U></B><BR><BR>";

class MiClase implements Iterator
{
    private $pases = array();
    
    // implementa la interface Iterator:
    // debe implementar los siguientes mtodos:
    // Iterator::rewind()
    // Iterator::current()
    // Iterator::key()
    // Iterator::next()
    // Iterator::valid()

    public function __construct($matriz)
    {
        // asigna los valores a la matriz privada
        if (is_array($matriz)) {
            $this->pases = $matriz;
        }
    }

    public function rewind() {
        // reposiciona el puntero del array 
        reset($this->pases);
    } 

    public function current() {
        // obtiene el elemento vigente         
        return current($this->pases); 
    }

    public function key() {
        // devuelve la clave del elemento vigente
        return key($this->pases); 
    }

    public function next() {
        // devuelve el elemento vigente
        return next($this->pases);
    }

    public function valid() {
        // elemento vlido?
        return $this->current() !== false;
    }
}

$matriz = array("Francia" => "Pars", "Italia" => "Roma", "Uruguay" => "Montevideo");
$obj = new MiClase($matriz);

foreach ($obj as $clave => $valor) {
    print "clave $clave => valor $valor <BR>";
}
?> 
