<?php
print "<B><U>__autoload() (ejemplo file106.php)</U></B><BR><BR>";

// ste es un modo de hacerlo sin __autoload()
//include_once "Personas.php";

function __autoload($varClase) {
	// con este print veremos cuntas veces se invoca a la 
   // funcin autoload()
	// Ser slo una vez, porque el archivo Personas.php contiene la
	// declaracin de las dos clases del programa

	print "<BR>** Entr a la funcin __autoload()**<BR><BR>";

	// la lgica dentro de la funcin __autoload() es libre
	// lo habitual es incluir la definicin de la clase faltante

	if ($varClase == "Empleado" or $varClase == "Persona") {
		include_once "Personas.php";
	}	
	else {
		include_once $varClase . ".php";
	}	 
}

// la clase Persona no est declarada dentro de la 
// secuencia de comandos vigente en lugar de producirse un error, 
// la uncin __autoload lo intercepta
// y se ejecuta. El parmetro que recibe la funcin es el nombre 
// de la clase que no est definida en el script

$obj = new Persona(122,"Jos Prez");
$obj->listar();

// como la clase Empleado est definida dentro del archivo 
// Personas.php cuando se hace referencia a la clase Empleado, 
// PHP detecta que la clase ya 
// est definida, ya que se carg junto con la clase Persona

$obj = new Empleado(99123,"Juan Fernndez","Recursos humanos");
$obj->listar();

?>